## ros-rolling-demo-nodes-cpp 0.19.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(demo_nodes_cpp)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(example_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(rcutils)
find_package(rmw REQUIRED)
find_package(std_msgs REQUIRED)

include_directories(include)

function(custom_executable subfolder target)
  add_executable(${target} src/${subfolder}/${target}.cpp)
  ament_target_dependencies(${target}
    "example_interfaces"
    "rclcpp"
    "rcutils"
    "std_msgs")
  install(TARGETS ${target}
  DESTINATION lib/${PROJECT_NAME})
endfunction()

function(add_demo_dependencies library)
  target_compile_definitions(${library}
    PRIVATE "DEMO_NODES_CPP_BUILDING_DLL")
  ament_target_dependencies(${library}
    "example_interfaces"
    "rclcpp"
    "rclcpp_components"
    "rcutils"
    "std_msgs")
endfunction()
# Tutorials of Publish/Subscribe with Topics
custom_executable(topics allocator_tutorial)

# Tutorials of Request/Response with Services
custom_executable(services add_two_ints_client)

# Tutorials of Parameters with Asynchronous and Synchronous
custom_executable(parameters list_parameters_async)
custom_executable(parameters parameter_events)
custom_executable(parameters parameter_event_handler)
custom_executable(parameters set_and_get_parameters_async)

add_library(timers_library SHARED
  src/timers/one_off_timer.cpp
  src/timers/reuse_timer.cpp)
add_library(services_library SHARED
  src/services/add_two_ints_server.cpp
  src/services/add_two_ints_client.cpp
  src/services/add_two_ints_client_async.cpp)
add_library(parameters_library SHARED
  src/parameters/list_parameters.cpp
  src/parameters/parameter_blackboard.cpp
  src/parameters/set_and_get_parameters.cpp
  src/parameters/parameter_events_async.cpp
  src/parameters/even_parameters_node.cpp)
add_library(topics_library SHARED
  src/topics/talker.cpp
  src/topics/talker_loaned_message.cpp
  src/topics/talker_serialized_message.cpp
  src/topics/listener.cpp
  src/topics/listener_serialized_message.cpp
  src/topics/listener_best_effort.cpp)
add_demo_dependencies(timers_library)
add_demo_dependencies(services_library)
add_demo_dependencies(parameters_library)
add_demo_dependencies(topics_library)

rclcpp_components_register_node(timers_library
  PLUGIN "demo_nodes_cpp::OneOffTimerNode"
  EXECUTABLE one_off_timer)
rclcpp_components_register_node(timers_library
  PLUGIN "demo_nodes_cpp::ReuseTimerNode"
  EXECUTABLE reuse_timer)

rclcpp_components_register_node(services_library
  PLUGIN "demo_nodes_cpp::ServerNode"
  EXECUTABLE add_two_ints_server)
rclcpp_components_register_node(services_library
  PLUGIN "demo_nodes_cpp::ClientNode"
  EXECUTABLE add_two_ints_client_async)

rclcpp_components_register_node(parameters_library
  PLUGIN "demo_nodes_cpp::ListParameters"
  EXECUTABLE list_parameters)
rclcpp_components_register_node(parameters_library
  PLUGIN "demo_nodes_cpp::ParameterBlackboard"
  EXECUTABLE parameter_blackboard)
rclcpp_components_register_node(parameters_library
  PLUGIN "demo_nodes_cpp::SetAndGetParameters"
  EXECUTABLE set_and_get_parameters)
rclcpp_components_register_node(parameters_library
  PLUGIN "demo_nodes_cpp::ParameterEventsAsyncNode"
  EXECUTABLE parameter_events_async)
rclcpp_components_register_node(parameters_library
  PLUGIN "demo_nodes_cpp::EvenParameterNode"
  EXECUTABLE even_parameters_node)

rclcpp_components_register_node(topics_library
  PLUGIN "demo_nodes_cpp::Talker"
  EXECUTABLE talker)
rclcpp_components_register_node(topics_library
  PLUGIN "demo_nodes_cpp::LoanedMessageTalker"
  EXECUTABLE talker_loaned_message)
rclcpp_components_register_node(topics_library
  PLUGIN "demo_nodes_cpp::SerializedMessageTalker"
  EXECUTABLE talker_serialized_message)
rclcpp_components_register_node(topics_library
  PLUGIN "demo_nodes_cpp::Listener"
  EXECUTABLE listener)
rclcpp_components_register_node(topics_library
  PLUGIN "demo_nodes_cpp::SerializedMessageListener"
  EXECUTABLE listener_serialized_message)
rclcpp_components_register_node(topics_library
  PLUGIN "demo_nodes_cpp::ListenerBestEffort"
  EXECUTABLE listener_best_effort)

install(TARGETS
  timers_library
  services_library
  parameters_library
  topics_library
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_pytest REQUIRED)
  find_package(launch_testing_ament_cmake REQUIRED)
  find_package(rmw_implementation_cmake REQUIRED)
  # Add each test case.  Multi-executable tests can be specified in
  # semicolon-separated strings, like  exe1;exe2.
  set(tutorial_tests
    list_parameters_async
    list_parameters
    parameter_events_async
    parameter_events
    set_and_get_parameters_async
    set_and_get_parameters
    "talker:listener")
  set(service_tutorial_tests
    "add_two_ints_server:add_two_ints_client"
    "add_two_ints_server:add_two_ints_client_async"
  )

  macro(tests)
    set(tutorial_tests_to_test ${tutorial_tests})
    list(APPEND tutorial_tests_to_test ${service_tutorial_tests})

    foreach(tutorial_test ${tutorial_tests_to_test})
      string(REPLACE ":" ";" tutorial_executables "${tutorial_test}")
      set(DEMO_NODES_CPP_EXPECTED_OUTPUT "")
      foreach(executable ${tutorial_executables})
        list(APPEND DEMO_NODES_CPP_EXPECTED_OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/test/${executable}")
      endforeach()

      set(DEMO_NODES_CPP_EXECUTABLE "")
      foreach(executable ${tutorial_executables})
        list(APPEND DEMO_NODES_CPP_EXECUTABLE "$<TARGET_FILE:${executable}>")
      endforeach()

      string(REPLACE ";" "_" exe_list_underscore "${tutorial_executables}")
      configure_file(
        test/test_executables_tutorial.py.in
        test_${exe_list_underscore}${target_suffix}.py.configured
        @ONLY
      )
      file(GENERATE
        OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/test_${exe_list_underscore}${target_suffix}_$<CONFIG>.py"
        INPUT "${CMAKE_CURRENT_BINARY_DIR}/test_${exe_list_underscore}${target_suffix}.py.configured"
      )

      add_launch_test(
        "${CMAKE_CURRENT_BINARY_DIR}/test_${exe_list_underscore}${target_suffix}_$<CONFIG>.py"
        TARGET test_tutorial_${exe_list_underscore}${target_suffix}
        TIMEOUT 60
        ENV
        RCL_ASSERT_RMW_ID_MATCHES=${rmw_implementation}
        RMW_IMPLEMENTATION=${rmw_implementation}
      )
      foreach(executable ${tutorial_executables})
        set_property(
          TEST test_tutorial_${exe_list_underscore}${target_suffix}
          APPEND PROPERTY DEPENDS ${executable}${target_suffix})
      endforeach()
    endforeach()
  endmacro()

  call_for_each_rmw_implementation(tests)
endif()

# Install launch files.
install(DIRECTORY
  launch
  DESTINATION share/${PROJECT_NAME}/
)

ament_package()

=== debian/changelog ===
ros-rolling-demo-nodes-cpp (0.19.0-1focal) focal; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Fri, 14 Jan 2022 08:00:00 -0000

ros-rolling-demo-nodes-cpp (0.18.0-1focal) focal; urgency=high

  * Update maintainers to Audrow Nash and Michael Jeronimo (#543 <https://github.com/ros2/demos/issues/543>)
  * Add how to fix the most vexing parse problem (#541 <https://github.com/ros2/demos/issues/541>)
    * use uniform initialization
  * Contributors: Audrow Nash, Tomoya Fujita

 -- Audrow Nash <audrow@openrobotics.org>  Fri, 17 Dec 2021 08:00:00 -0000

ros-rolling-demo-nodes-cpp (0.17.0-1focal) focal; urgency=high

  * Fixing deprecated subscriber callback warnings (#532 <https://github.com/ros2/demos/issues/532>)
  * Contributors: Abrar Rahman Protyasha

 -- Mabel Zhang <mabel@openrobotics.org>  Mon, 18 Oct 2021 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.16.0-1focal) focal; urgency=high

  * Update talker_loaned_message.cpp (#518 <https://github.com/ros2/demos/issues/518>)
  * Contributors: Zongbao Feng

 -- Mabel Zhang <mabel@openrobotics.org>  Wed, 11 Aug 2021 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.15.0-1focal) focal; urgency=high

  * Revert "Use sizeof(char) in place for sizeof(void) (#515 <https://github.com/ros2/demos/issues/515>)" (#516 <https://github.com/ros2/demos/issues/516>)
  * change how serialized message works with subscription (#497 <https://github.com/ros2/demos/issues/497>)
  * Use sizeof(char) in place for sizeof(void) (#515 <https://github.com/ros2/demos/issues/515>)
  * Fix small print issue in allocator tutorial. (#509 <https://github.com/ros2/demos/issues/509>)
  * Contributors: Chris Lalancette, Michel Hidalgo, William Woodall

 -- Mabel Zhang <mabel@openrobotics.org>  Fri, 14 May 2021 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.14.2-1focal) focal; urgency=high

  * Small fixes for even_parameters_node. (#500 <https://github.com/ros2/demos/issues/500>)
  * Contributors: Chris Lalancette

 -- Mabel Zhang <mabel@openrobotics.org>  Mon, 26 Apr 2021 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.14.1-1focal) focal; urgency=high



 -- Mabel Zhang <mabel@openrobotics.org>  Mon, 19 Apr 2021 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.14.0-1focal) focal; urgency=high

  * change ParameterEventHandler to take events as const ref instead of shared pointer (#494 <https://github.com/ros2/demos/issues/494>)
  * Fix integer type in RCLCPP_* macro printf. (#492 <https://github.com/ros2/demos/issues/492>)
  * Contributors: Chris Lalancette, William Woodall

 -- Mabel Zhang <mabel@openrobotics.org>  Tue, 06 Apr 2021 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.13.0-1focal) focal; urgency=high

  * Add a demo for the new ParameterEventHandler class (#486 <https://github.com/ros2/demos/issues/486>)
  * Contributors: Michael Jeronimo

 -- Mabel Zhang <mabel@openrobotics.org>  Thu, 25 Mar 2021 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.12.1-1focal) focal; urgency=high

  * Filter qos overrides in paramter events demos (#491 <https://github.com/ros2/demos/issues/491>)
  * Update code now that parameter types are static by default (#487 <https://github.com/ros2/demos/issues/487>)
  * Contributors: Ivan Santiago Paunovic

 -- Mabel Zhang <mabel@openrobotics.org>  Thu, 18 Mar 2021 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.12.0-1focal) focal; urgency=high

  * Update logging macros (#476 <https://github.com/ros2/demos/issues/476>)
  * Contributors: Audrow Nash

 -- Mabel Zhang <mabel@openrobotics.org>  Mon, 25 Jan 2021 08:00:00 -0000

ros-rolling-demo-nodes-cpp (0.11.0-1focal) focal; urgency=high

  * Make sure to wait for the service before declaring events. (#473 <https://github.com/ros2/demos/issues/473>)
  * Update the package.xml files with the latest Open Robotics maintainers (#466 <https://github.com/ros2/demos/issues/466>)
  * Contributors: Chris Lalancette, Michael Jeronimo

 -- Mabel Zhang <mabel@openrobotics.org>  Thu, 10 Dec 2020 08:00:00 -0000

ros-rolling-demo-nodes-cpp (0.10.1-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 21 Sep 2020 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.10.0-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 17 Jun 2020 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.9.3-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 01 Jun 2020 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.9.2-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Tue, 26 May 2020 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.9.1-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Tue, 12 May 2020 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.9.0-1focal) focal; urgency=high

  * avoid new deprecations (#442 <https://github.com/ros2/demos/issues/442>)
  * use serialized message (#441 <https://github.com/ros2/demos/issues/441>)
  * Replace deprecated launch_ros usage (#437 <https://github.com/ros2/demos/issues/437>)
  * code style only: wrap after open parenthesis if not in one line (#429 <https://github.com/ros2/demos/issues/429>)
  * Use spin_until_future_complete instead of spin_some in parameters_event demo (#427 <https://github.com/ros2/demos/issues/427>)
  * change the logging demo test for updated console format (#421 <https://github.com/ros2/demos/issues/421>)
  * [demo_nodes_cpp]  Add XML launch demos (#419 <https://github.com/ros2/demos/issues/419>)
  * Contributors: Dirk Thomas, Ivan Santiago Paunovic, Jacob Perron, Karsten Knese, Steven Macenski, William Woodall, Yutaka Kondo

 -- William Woodall <william@osrfoundation.org>  Thu, 30 Apr 2020 07:00:00 -0000

ros-rolling-demo-nodes-cpp (0.8.4-1focal) focal; urgency=high

  * Add in a more helpful usage message to allocator_tutorial. (#409 <https://github.com/ros2/demos/issues/409>)
  * Contributors: Chris Lalancette

 -- William Woodall <william@osrfoundation.org>  Tue, 19 Nov 2019 08:00:00 -0000



=== debian/control ===
Source: ros-rolling-demo-nodes-cpp
Section: misc
Priority: optional
Maintainer: Audrow Nash <audrow@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-cmake-pytest, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-example-interfaces, ros-rolling-launch, ros-rolling-launch-testing, ros-rolling-launch-testing-ament-cmake, ros-rolling-launch-testing-ros, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-rmw-implementation-cmake, ros-rolling-std-msgs, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-demo-nodes-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-example-interfaces, ros-rolling-launch-ros, ros-rolling-launch-xml, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-std-msgs, ros-rolling-ros-workspace
Description: C++ nodes which were previously in the ros2/examples repository but are now just used for demo purposes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-demo-nodes-cpp//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-demo-nodes-cpp 0.31.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(demo_nodes_cpp)

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(example_interfaces REQUIRED)
find_package(rcl REQUIRED)
find_package(rcl_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(std_msgs REQUIRED)

function(custom_executable subfolder target)
  cmake_parse_arguments(ARG "" "" "DEPENDENCIES" ${ARGN})
  add_executable(${target} src/${subfolder}/${target}.cpp)
  target_include_directories(${target} PRIVATE
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
    "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")
  target_link_libraries(${target} PRIVATE
    ${ARG_DEPENDENCIES}
  )
  install(TARGETS ${target}
    DESTINATION lib/${PROJECT_NAME})
endfunction()

custom_executable(topics allocator_tutorial
  DEPENDENCIES rclcpp::rclcpp ${std_msgs_TARGETS})

custom_executable(services add_two_ints_client
  DEPENDENCIES ${example_interfaces_TARGETS} rclcpp::rclcpp)

custom_executable(parameters list_parameters_async
  DEPENDENCIES rclcpp::rclcpp)

custom_executable(parameters parameter_events
  DEPENDENCIES ${rcl_interfaces_TARGETS} rclcpp::rclcpp)

custom_executable(parameters parameter_event_handler
  DEPENDENCIES ${rcl_interfaces_TARGETS} rclcpp::rclcpp)

custom_executable(parameters set_and_get_parameters_async
  DEPENDENCIES rclcpp::rclcpp)

custom_executable(events matched_event_detect
  DEPENDENCIES rclcpp::rclcpp ${std_msgs_TARGETS})

custom_executable(logging use_logger_service
  DEPENDENCIES ${rcl_interfaces_TARGETS} rclcpp::rclcpp ${std_msgs_TARGETS})

function(create_demo_library plugin executable)
  cmake_parse_arguments(ARG "" "" "FILES;DEPENDENCIES" ${ARGN})
  set(library ${executable}_library)
  add_library(${library} SHARED ${ARG_FILES})
  target_compile_definitions(${library}
    PRIVATE "DEMO_NODES_CPP_BUILDING_DLL")
  target_include_directories(${library} PRIVATE
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
    "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")
  target_link_libraries(${library} PRIVATE
    ${ARG_DEPENDENCIES}
  )
  install(TARGETS ${library}
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION bin)
  rclcpp_components_register_node(${library}
    PLUGIN ${plugin}
    EXECUTABLE ${executable})
endfunction()

# Timers
create_demo_library("demo_nodes_cpp::OneOffTimerNode" one_off_timer
  FILES src/timers/one_off_timer.cpp
  DEPENDENCIES rclcpp::rclcpp rclcpp_components::component)
create_demo_library("demo_nodes_cpp::ReuseTimerNode" reuse_timer
  FILES src/timers/reuse_timer.cpp
  DEPENDENCIES rclcpp::rclcpp rclcpp_components::component)

# Parameters
create_demo_library("demo_nodes_cpp::ListParameters" list_parameters
  FILES src/parameters/list_parameters.cpp
  DEPENDENCIES rclcpp::rclcpp rclcpp_components::component)
create_demo_library("demo_nodes_cpp::ParameterBlackboard" parameter_blackboard
  FILES src/parameters/parameter_blackboard.cpp
  DEPENDENCIES ${rcl_interfaces_TARGETS} rclcpp::rclcpp rclcpp_components::component)
create_demo_library("demo_nodes_cpp::SetAndGetParameters" set_and_get_parameters
  FILES src/parameters/set_and_get_parameters.cpp
  DEPENDENCIES rclcpp::rclcpp rclcpp_components::component)
create_demo_library("demo_nodes_cpp::ParameterEventsAsyncNode" parameter_events_async
  FILES src/parameters/parameter_events_async.cpp
  DEPENDENCIES ${rcl_interfaces_TARGETS} rclcpp::rclcpp rclcpp_components::component)
create_demo_library("demo_nodes_cpp::EvenParameterNode" event_parameters_node
  FILES src/parameters/even_parameters_node.cpp
  DEPENDENCIES ${rcl_interfaces_TARGETS} rclcpp::rclcpp rclcpp_components::component)
create_demo_library("demo_nodes_cpp::SetParametersCallback" set_parameters_callback
  FILES src/parameters/set_parameters_callback.cpp
  DEPENDENCIES ${rcl_interfaces_TARGETS} rclcpp::rclcpp rclcpp_components::component)

# Services
create_demo_library("demo_nodes_cpp::ServerNode" add_two_ints_server
  FILES src/services/add_two_ints_server.cpp
  DEPENDENCIES ${example_interfaces_TARGETS} rclcpp::rclcpp rclcpp_components::component)
create_demo_library("demo_nodes_cpp::ClientNode" add_two_ints_client_async
  FILES src/services/add_two_ints_client_async.cpp
  DEPENDENCIES ${example_interfaces_TARGETS} rclcpp::rclcpp rclcpp_components::component)
create_demo_library("demo_nodes_cpp::IntrospectionServiceNode" introspection_service
  FILES src/services/introspection_service.cpp
  DEPENDENCIES ${example_interfaces_TARGETS} ${rcl_interfaces_TARGETS} rcl::rcl rclcpp::rclcpp rclcpp_components::component)
create_demo_library("demo_nodes_cpp::IntrospectionClientNode" introspection_client
  FILES src/services/introspection_client.cpp
  DEPENDENCIES ${example_interfaces_TARGETS} ${rcl_interfaces_TARGETS} rcl::rcl rclcpp::rclcpp rclcpp_components::component)

# Topics
create_demo_library("demo_nodes_cpp::ContentFilteringPublisher" content_filtering_publisher
  FILES src/topics/content_filtering_publisher.cpp
  DEPENDENCIES rclcpp::rclcpp rclcpp_components::component ${std_msgs_TARGETS})
create_demo_library("demo_nodes_cpp::ContentFilteringSubscriber" content_filtering_subscriber
  FILES src/topics/content_filtering_subscriber.cpp
  DEPENDENCIES rclcpp::rclcpp rclcpp_components::component rcpputils::rcpputils ${std_msgs_TARGETS})
create_demo_library("demo_nodes_cpp::Talker" talker
  FILES src/topics/talker.cpp
  DEPENDENCIES rclcpp::rclcpp rclcpp_components::component ${std_msgs_TARGETS})
create_demo_library("demo_nodes_cpp::LoanedMessageTalker" talker_loaned_message
  FILES src/topics/talker_loaned_message.cpp
  DEPENDENCIES rclcpp::rclcpp rclcpp_components::component ${std_msgs_TARGETS})
create_demo_library("demo_nodes_cpp::SerializedMessageTalker" talker_serialized_message
  FILES src/topics/talker_serialized_message.cpp
  DEPENDENCIES rclcpp::rclcpp rclcpp_components::component ${std_msgs_TARGETS})
create_demo_library("demo_nodes_cpp::Listener" listener
  FILES src/topics/listener.cpp
  DEPENDENCIES rclcpp::rclcpp rclcpp_components::component ${std_msgs_TARGETS})
create_demo_library("demo_nodes_cpp::SerializedMessageListener" listener_serialized_message
  FILES src/topics/listener_serialized_message.cpp
  DEPENDENCIES rclcpp::rclcpp rclcpp_components::component ${std_msgs_TARGETS})
create_demo_library("demo_nodes_cpp::ListenerBestEffort" listener_best_effort
  FILES src/topics/listener_best_effort.cpp
  DEPENDENCIES rclcpp::rclcpp rclcpp_components::component ${std_msgs_TARGETS})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_pytest REQUIRED)
  find_package(launch_testing_ament_cmake REQUIRED)
  find_package(rmw_implementation_cmake REQUIRED)
  # Add each test case.  Multi-executable tests can be specified in
  # semicolon-separated strings, like  exe1;exe2.
  set(tutorial_tests
    "content_filtering_publisher@publish_ms=100:content_filtering_subscriber"
    list_parameters_async
    list_parameters
    parameter_events_async
    parameter_events
    set_and_get_parameters_async
    set_and_get_parameters
    matched_event_detect
    use_logger_service
    "talker:listener"
  )
  set(service_tutorial_tests
    "add_two_ints_server@one_shot=True:add_two_ints_client"
    "add_two_ints_server@one_shot=True:add_two_ints_client_async"
  )

  macro(tests)
    set(tutorial_tests_to_test ${tutorial_tests})
    list(APPEND tutorial_tests_to_test ${service_tutorial_tests})

    foreach(tutorial_test ${tutorial_tests_to_test})
      set(DEMO_NODES_CPP_EXPECTED_OUTPUT "")
      set(DEMO_NODES_CPP_EXECUTABLE "")
      set(exe_list "")

      # We're expecting each tutorial_test to be of the form:
      #
      # exe1[@param1=value1@param2=value2][:exe2[@param3=value3@param4=value4]]
      #
      # That is, you can have one or more executables, and each of those
      # executables can be passed zero or more parameters.
      #
      # Unfortunately, we need to parse this list here in CMake since we need
      # to know the executable name so we can generate an absolute path.

      # Convert the colon-separated list we were given to a semi-colon
      # separated one so we can iterate over it in CMake.
      string(REPLACE ":" ";" exes_and_params "${tutorial_test}")
      foreach(exe_and_params ${exes_and_params})
        string(REPLACE "@" ";" params ${exe_and_params})
        # It is expected that the first variable is the executable
        list(GET params 0 executable)
        list(APPEND DEMO_NODES_CPP_EXPECTED_OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/test/${executable}")
        list(APPEND exe_list ${executable})
        set(target_file "$<TARGET_FILE:${executable}>")

        # If there is anything left in the list at this time, assume they
        # are parameters.
        list(LENGTH params list_length)
        if(${list_length} GREATER 1)
          list(SUBLIST params 1 -1 params_only)
          string(JOIN "@" target_file ${target_file} ${params_only})
        endif()

        # This is what will get substituted into test_executables_tutorial.py.in below.
        # It looks exactly the same as exes_and_params, with the exception
        # that the executable names have been substituted for the absolute paths.
        list(APPEND DEMO_NODES_CPP_EXECUTABLE ${target_file})
      endforeach()
      string(REPLACE ";" "_" exe_list_underscore "${exe_list}")
      configure_file(
        test/test_executables_tutorial.py.in
        test_${exe_list_underscore}${target_suffix}.py.configured
        @ONLY
      )
      file(GENERATE
        OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/test_${exe_list_underscore}${target_suffix}_$<CONFIG>.py"
        INPUT "${CMAKE_CURRENT_BINARY_DIR}/test_${exe_list_underscore}${target_suffix}.py.configured"
      )

      add_launch_test(
        "${CMAKE_CURRENT_BINARY_DIR}/test_${exe_list_underscore}${target_suffix}_$<CONFIG>.py"
        TARGET test_tutorial_${exe_list_underscore}${target_suffix}
        TIMEOUT 60
        ENV
        RCL_ASSERT_RMW_ID_MATCHES=${rmw_implementation}
        RMW_IMPLEMENTATION=${rmw_implementation}
      )
      foreach(executable ${exe_list})
        set_property(
          TEST test_tutorial_${exe_list_underscore}${target_suffix}
          APPEND PROPERTY DEPENDS ${executable}${target_suffix})
      endforeach()
    endforeach()
  endmacro()

  call_for_each_rmw_implementation(tests)
endif()

# Install launch files.
install(DIRECTORY
  launch
  DESTINATION share/${PROJECT_NAME}/
)

ament_package()

=== debian/changelog ===
ros-rolling-demo-nodes-cpp (0.31.1-1jammy) jammy; urgency=high

  * Remove unnecessary captures in the various demos. (#647 <https://github.com/ros2/demos/issues/647>)
  * Contributors: Chris Lalancette

 -- Aditya Pande <aditya.pande@openrobotics.org>  Thu, 07 Sep 2023 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.31.0-1jammy) jammy; urgency=high

  * Dramatically speed up the demo_nodes_cpp tests (#641 <https://github.com/ros2/demos/issues/641>)
  * Switch to using RCLCPP logging macros in the lifecycle package. (#644 <https://github.com/ros2/demos/issues/644>)
  * Contributors: Chris Lalancette

 -- Aditya Pande <aditya.pande@openrobotics.org>  Mon, 21 Aug 2023 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.30.1-1jammy) jammy; urgency=high

  * failed to call introspection_client (#643 <https://github.com/ros2/demos/issues/643>)
  * Contributors: Chen Lihui

 -- Aditya Pande <aditya.pande@openrobotics.org>  Tue, 11 Jul 2023 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.30.0-1jammy) jammy; urgency=high

  * Small cleanups to the demos when running through them. (#639 <https://github.com/ros2/demos/issues/639>)
  * Cleanup demo_nodes_cpp CMake and dependencies (#638 <https://github.com/ros2/demos/issues/638>)
  * Change the service introspection parameter off value to 'disabled' (#634 <https://github.com/ros2/demos/issues/634>)
  * Contributors: Chris Lalancette

 -- Aditya Pande <aditya.pande@openrobotics.org>  Mon, 12 Jun 2023 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.29.0-1jammy) jammy; urgency=high

  * Add demos for using logger service (#611 <https://github.com/ros2/demos/issues/611>)
  * Contributors: Barry Xu

 -- Aditya Pande <aditya.pande@openrobotics.org>  Wed, 07 Jun 2023 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.28.1-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Thu, 11 May 2023 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.28.0-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Thu, 27 Apr 2023 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.27.0-1jammy) jammy; urgency=high

  * Change all ROS2 -> ROS 2. (#610 <https://github.com/ros2/demos/issues/610>)
  * Add matched event demo for rclcpp and rclpy (#607 <https://github.com/ros2/demos/issues/607>)
  * Contributors: Barry Xu, Chris Lalancette

 -- Aditya Pande <aditya.pande@openrobotics.org>  Thu, 13 Apr 2023 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.26.0-1jammy) jammy; urgency=high

  * Fix the set_parameters_callback example program. (#608 <https://github.com/ros2/demos/issues/608>)
  * [demo_nodes_cpp] Add YAML launch demos for topics (#605 <https://github.com/ros2/demos/issues/605>)
  * update launch file name format to match documentation (#588 <https://github.com/ros2/demos/issues/588>)
  * Contributors: Chris Lalancette, Damien LaRocque, Patrick Wspanialy

 -- Aditya Pande <aditya.pande@openrobotics.org>  Tue, 11 Apr 2023 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.25.0-1jammy) jammy; urgency=high

  * Service introspection (#602 <https://github.com/ros2/demos/issues/602>)
    * Add in a rclcpp and rclpy demo of introspection.
  * Contributors: Chris Lalancette

 -- Aditya Pande <aditya.pande@openrobotics.org>  Wed, 01 Mar 2023 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.24.1-1jammy) jammy; urgency=high

  * Added README.md for demo_cpp_nodes (#599 <https://github.com/ros2/demos/issues/599>)
  * Contributors: Gary Bey

 -- Aditya Pande <aditya.pande@openrobotics.org>  Fri, 24 Feb 2023 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.24.0-1jammy) jammy; urgency=high

  * Update the demos to C++17. (#594 <https://github.com/ros2/demos/issues/594>)
  * [rolling] Update maintainers - 2022-11-07 (#589 <https://github.com/ros2/demos/issues/589>)
  * Contributors: Audrow Nash, Chris Lalancette

 -- Aditya Pande <aditya.pande@openrobotics.org>  Tue, 14 Feb 2023 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.23.0-1jammy) jammy; urgency=high

  * Demo for pre and post set parameter callback support (#565 <https://github.com/ros2/demos/issues/565>)
    * local parameter callback support
  * Contributors: Deepanshu Bansal

 -- Aditya Pande <aditya.pande@openrobotics.org>  Wed, 02 Nov 2022 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.22.0-1jammy) jammy; urgency=high

  * counter starts from 1, not 2. (#562 <https://github.com/ros2/demos/issues/562>)
  * add a demo of content filter listener (#557 <https://github.com/ros2/demos/issues/557>)
  * Contributors: Chen Lihui, Tomoya Fujita

 -- Aditya Pande <aditya.pande@openrobotics.org>  Tue, 13 Sep 2022 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.21.0-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Fri, 29 Apr 2022 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.20.1-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Fri, 08 Apr 2022 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.20.0-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Tue, 01 Mar 2022 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.19.0-1jammy) jammy; urgency=high



 -- Aditya Pande <aditya.pande@openrobotics.org>  Fri, 14 Jan 2022 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.18.0-1jammy) jammy; urgency=high

  * Update maintainers to Audrow Nash and Michael Jeronimo (#543 <https://github.com/ros2/demos/issues/543>)
  * Add how to fix the most vexing parse problem (#541 <https://github.com/ros2/demos/issues/541>)
    * use uniform initialization
  * Contributors: Audrow Nash, Tomoya Fujita

 -- Aditya Pande <aditya.pande@openrobotics.org>  Fri, 17 Dec 2021 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.17.0-1jammy) jammy; urgency=high

  * Fixing deprecated subscriber callback warnings (#532 <https://github.com/ros2/demos/issues/532>)
  * Contributors: Abrar Rahman Protyasha

 -- Aditya Pande <aditya.pande@openrobotics.org>  Mon, 18 Oct 2021 00:00:00 -0000

ros-rolling-demo-nodes-cpp (0.16.0-1jammy) jammy; urgency=high



=== debian/control ===
Source: ros-rolling-demo-nodes-cpp
Section: misc
Priority: optional
Maintainer: Aditya Pande <aditya.pande@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-cmake-pytest <!nocheck>, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-example-interfaces, ros-rolling-launch <!nocheck>, ros-rolling-launch-testing <!nocheck>, ros-rolling-launch-testing-ament-cmake <!nocheck>, ros-rolling-launch-testing-ros <!nocheck>, ros-rolling-rcl, ros-rolling-rcl-interfaces, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rcpputils, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-std-msgs, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-demo-nodes-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-example-interfaces, ros-rolling-launch-ros, ros-rolling-launch-xml, ros-rolling-rcl, ros-rolling-rcl-interfaces, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rcpputils, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-std-msgs, ros-rolling-ros-workspace
Description: C++ nodes which were previously in the ros2/examples repository but are now just used for demo purposes.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
